// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/multiplier.hpp"



multiplier::multiplier( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    clk("clk"),
    din_rdy("din_rdy"),
    op1("op1"),
    op2("op2"),
    result("result"),
    dout_rdy("dout_rdy"),
    clkSuphif_1("clkSuphif_1")
{
    result.initialize( 0UL );
    dout_rdy.initialize( false );
    clkSuphif_1 = false;

    SC_METHOD( vhdl_process );
    sensitive << clk;

    SC_METHOD( UpdclkSuphif_1 );
    sensitive << clk;
}

multiplier::~multiplier()
{}

void multiplier::vhdl_process()
{
    if (clk.read() != clkSuphif_1.read() && clk.read() == true)
    {
        if (din_rdy.read() == true)
        {
            result = op1.read() * op2.read();
            dout_rdy = true;
        }
        else
        {
            result = 0UL;
            dout_rdy = false;
        }
    }
}

void multiplier::UpdclkSuphif_1()
{
    clkSuphif_1 = clk.read();
}



